// http://www.cocos2d-iphone.org

varying vec4 v_fragmentColor; 
varying vec2 v_texCoord;
uniform float width;
uniform float dist; 

float getColorByCoord(float x){
	float a = 2. / (2. * (dist * dist) - (4. * dist * dist));
	float b = 4. * dist / ((4. * dist * dist) - 2. * (dist * dist));
    if (x < dist) {
		return a * (x * x) + b * x;
	} else if (x > (width - dist)){
		return a * ((width - x) * (width - x)) + b * (width - x);
	} else {
		return 1.;
	}
}

float getColorByCoordX(float x){
    if (x < dist) {
		return (x * x) / (dist * dist);
	} else if (x > (width - dist)){
		return((width - x) * (width - x)) / (dist * dist);
	} else {
		return 1.;
	}
}

void main(void) {
	vec4 v_orColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);
	float coord = getColorByCoordX(gl_FragCoord.x);
	v_orColor = v_orColor * vec4(0, 0, 0, coord);
	gl_FragColor = v_orColor;
}